package com.elsevier.example.music.quarkus;

import com.elsevier.example.music.quarkus.reader.ChartEntryReader;
import com.elsevier.example.music.quarkus.reader.ChartEntryReaderFactory;
import com.elsevier.example.music.quarkus.writer.ChartEntryWriter;
import com.elsevier.example.music.quarkus.writer.ChartEntryWriterFactory;

import java.util.Set;

public class ChartEntryCopier {

    private static final Set<String> FILTERED_ARTISTS = Set.of("EVANESCENCE", "FEEDER", "LINKIN PARK");
    private final ChartEntryReaderFactory chartEntryReaderFactory;
    private final ChartEntryWriterFactory ChartEntryWriterFactory;

    public ChartEntryCopier(ChartEntryReaderFactory chartEntryReaderFactory, ChartEntryWriterFactory chartEntryWriterFactory) {
        this.chartEntryReaderFactory = chartEntryReaderFactory;
        ChartEntryWriterFactory = chartEntryWriterFactory;
    }

    public void copyEntries() {
        try (ChartEntryReader chartEntryReader = chartEntryReaderFactory.build();
             ChartEntryWriter chartEntryWriter = ChartEntryWriterFactory.build()) {
            chartEntryReader.getStream()
                    .filter(chartEntry -> FILTERED_ARTISTS.contains(chartEntry.getArtist()))
                    .forEach(chartEntryWriter::write);
        }
    }
}
